from django.contrib.admin.sites import AdminSite

class RootAdminSite(AdminSite):
    index_template = 'adminroot/index.html'
    def has_permission(self, request):
        """
        Returns True if the given HttpRequest has permission to view
        *at least one* page in the admin site.
        """
        return request.user.is_active and request.user.is_superuser


# This global object represents the default admin site, for the common case.
# You can instantiate AdminSite in your own code to create a custom admin site.
root_site = RootAdminSite()
