# encoding: utf-8
import datetime
from south.db import db
from south.v2 import SchemaMigration
from django.db import models

class Migration(SchemaMigration):

    def forwards(self, orm):
        
        # Adding model 'Bank'
        db.create_table('abicab_bank', (
            ('id', self.gf('django.db.models.fields.AutoField')(primary_key=True)),
            ('date_create', self.gf('django.db.models.fields.DateTimeField')(null=True, blank=True)),
            ('date_last_modify', self.gf('django.db.models.fields.DateTimeField')(null=True, blank=True)),
            ('status', self.gf('jumbo.db.fields.StatusField')()),
            ('creator', self.gf('django.db.models.ForeignKey')(blank=True, related_name='abicab_bank_creator', null=True, to=orm['auth.User'])),
            ('last_modifier', self.gf('django.db.models.ForeignKey')(blank=True, related_name='abicab_bank_last_modifier', null=True, to=orm['auth.User'])),
            ('abi', self.gf('django.db.models.fields.CharField')(max_length=5, db_index=True)),
            ('cab', self.gf('django.db.models.fields.CharField')(max_length=5, db_index=True)),
            ('name', self.gf('django.db.models.fields.CharField')(max_length=100, db_index=True)),
            ('agency', self.gf('django.db.models.fields.CharField')(max_length=100, db_index=True)),
            ('address', self.gf('django.db.models.fields.CharField')(max_length=100, db_index=True)),
            ('zip_code', self.gf('django.db.models.fields.CharField')(max_length=5, db_index=True)),
            ('locality', self.gf('django.db.models.fields.CharField')(max_length=100, db_index=True)),
            ('province', self.gf('django.db.models.fields.CharField')(max_length=2, db_index=True)),
            ('country', self.gf('django.db.models.fields.related.ForeignKey')(default=108, to=orm['l10n.Country'])),
        ))
        db.send_create_signal('abicab', ['Bank'])

        # Adding unique constraint on 'Bank', fields ['abi', 'cab']
        db.create_unique('abicab_bank', ['abi', 'cab'])


    def backwards(self, orm):
        
        # Deleting model 'Bank'
        db.delete_table('abicab_bank')

        # Removing unique constraint on 'Bank', fields ['abi', 'cab']
        db.delete_unique('abicab_bank', ['abi', 'cab'])


    models = {
        'abicab.bank': {
            'Meta': {'unique_together': "(('abi', 'cab'),)", 'object_name': 'Bank'},
            'abi': ('django.db.models.fields.CharField', [], {'max_length': '5', 'db_index': 'True'}),
            'address': ('django.db.models.fields.CharField', [], {'max_length': '100', 'db_index': 'True'}),
            'agency': ('django.db.models.fields.CharField', [], {'max_length': '100', 'db_index': 'True'}),
            'cab': ('django.db.models.fields.CharField', [], {'max_length': '5', 'db_index': 'True'}),
            'country': ('django.db.models.fields.related.ForeignKey', [], {'default': '108', 'to': "orm['l10n.Country']"}),
            'creator': ('django.db.models.ForeignKey', [], {'blank': 'True', 'related_name': "'abicab_bank_creator'", 'null': 'True', 'to': "orm['auth.User']"}),
            'date_create': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'blank': 'True'}),
            'date_last_modify': ('django.db.models.fields.DateTimeField', [], {'null': 'True', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'last_modifier': ('django.db.models.ForeignKey', [], {'blank': 'True', 'related_name': "'abicab_bank_last_modifier'", 'null': 'True', 'to': "orm['auth.User']"}),
            'locality': ('django.db.models.fields.CharField', [], {'max_length': '100', 'db_index': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100', 'db_index': 'True'}),
            'province': ('django.db.models.fields.CharField', [], {'max_length': '2', 'db_index': 'True'}),
            'status': ('jumbo.db.fields.StatusField', [], {}),
            'zip_code': ('django.db.models.fields.CharField', [], {'max_length': '5', 'db_index': 'True'})
        },
        'auth.group': {
            'Meta': {'object_name': 'Group'},
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '80'}),
            'permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'})
        },
        'auth.permission': {
            'Meta': {'unique_together': "(('content_type', 'codename'),)", 'object_name': 'Permission'},
            'codename': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'content_type': ('django.db.models.fields.related.ForeignKey', [], {'to': "orm['contenttypes.ContentType']"}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '50'})
        },
        'auth.user': {
            'Meta': {'object_name': 'User'},
            'date_joined': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'email': ('django.db.models.fields.EmailField', [], {'max_length': '75', 'blank': 'True'}),
            'first_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'groups': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Group']", 'symmetrical': 'False', 'blank': 'True'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'is_active': ('django.db.models.fields.BooleanField', [], {'default': 'True', 'blank': 'True'}),
            'is_staff': ('django.db.models.fields.BooleanField', [], {'default': 'False', 'blank': 'True'}),
            'is_superuser': ('django.db.models.fields.BooleanField', [], {'default': 'False', 'blank': 'True'}),
            'last_login': ('django.db.models.fields.DateTimeField', [], {'default': 'datetime.datetime.now'}),
            'last_name': ('django.db.models.fields.CharField', [], {'max_length': '30', 'blank': 'True'}),
            'password': ('django.db.models.fields.CharField', [], {'max_length': '128'}),
            'user_permissions': ('django.db.models.fields.related.ManyToManyField', [], {'to': "orm['auth.Permission']", 'symmetrical': 'False', 'blank': 'True'}),
            'username': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '30'})
        },
        'contenttypes.contenttype': {
            'Meta': {'unique_together': "(('app_label', 'model'),)", 'object_name': 'ContentType', 'db_table': "'django_content_type'"},
            'app_label': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'model': ('django.db.models.fields.CharField', [], {'max_length': '100'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '100'})
        },
        'l10n.country': {
            'Meta': {'object_name': 'Country'},
            'active': ('django.db.models.fields.BooleanField', [], {'default': 'True', 'blank': 'True'}),
            'admin_area': ('django.db.models.fields.CharField', [], {'db_index': 'True', 'max_length': '2', 'null': 'True', 'blank': 'True'}),
            'continent': ('django.db.models.fields.CharField', [], {'max_length': '2'}),
            'id': ('django.db.models.fields.AutoField', [], {'primary_key': 'True'}),
            'iso2_code': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '2', 'db_index': 'True'}),
            'iso3_code': ('django.db.models.fields.CharField', [], {'unique': 'True', 'max_length': '3'}),
            'name': ('django.db.models.fields.CharField', [], {'max_length': '128', 'db_index': 'True'}),
            'numcode': ('django.db.models.fields.PositiveSmallIntegerField', [], {'null': 'True', 'blank': 'True'}),
            'printable_name': ('django.db.models.fields.CharField', [], {'max_length': '128', 'db_index': 'True'})
        }
    }

    complete_apps = ['abicab']
