# -*- coding: utf-8 -*-
from django.db import models
from django.utils.translation import ugettext_lazy as _
from django.template.defaultfilters import slugify

from jumbo.db.models import OrderedModel, StatusModel, DateModel, UserModel
from jumbo.apps.l10n.models import Country

class Bank (DateModel, UserModel, StatusModel):
    abi = models.CharField (
        max_length = 5,
        db_index = True,
        verbose_name = _("abi"),
    )
    cab = models.CharField (
        max_length = 5,
        db_index = True,
        verbose_name = _("cab"),
    )
    name = models.CharField (
        max_length = 100,
        db_index = True,
        verbose_name = _("name"),
    )
    agency = models.CharField (
        max_length = 100,
        db_index = True,
        verbose_name = _("agency"),
    )
    address = models.CharField (
        max_length = 100,
        db_index = True,
        verbose_name = _("address"),
    )
    zip_code = models.CharField (
        max_length = 5,
        db_index = True,
        verbose_name = _("zip code"),
    )
    locality = models.CharField (
        max_length = 100,
        db_index = True,
        verbose_name = _("locality"),
    )
    province = models.CharField (
        max_length = 2,
        db_index = True,
        verbose_name = _("province"),
    )
    country = models.ForeignKey (
        Country,
        db_index = True,
        default = 108, # id of Italy Country
        verbose_name = _("country"),
    )

    class Meta:
        verbose_name = _("bank")
        verbose_name_plural = _("banks")
        unique_together = (('abi', 'cab'),)

    def __unicode__(self):
        return u"%s" % self.name


