from django.conf import settings
from django import forms
from django.contrib.comments.forms import CommentForm
from django.utils.translation import ungettext, ugettext_lazy as _
from tinymce import widgets as tinymce_widgets


COMMENT_MAX_LENGTH = getattr(settings,'COMMENT_MAX_LENGTH', 3000)

class JumboCommentForm(CommentForm):
    comment = forms.CharField(label=_('Comment'), max_length=COMMENT_MAX_LENGTH,
                              widget = tinymce_widgets.TinyMCE(mce_attrs={'width':'93%'}))
