# -*- coding: utf-8 -*-

from south.db import db
from jumbo.db import HackForeignKey
from django.db import models
from jumbo.db.models import StatusField
from jumbo.apps.menu.models import *

class Migration:
    
    def forwards(self, orm):
        
        # Adding field 'MenuTranslation.menu'
        db.add_column('menu_menutranslation', 'menu', models.ForeignKey(orm.Menu, verbose_name=_('menu')))
        
        # Adding field 'MenuTranslation.caption'
        db.add_column('menu_menutranslation', 'caption', models.CharField(max_length=50, verbose_name=_('translated caption')))
        
        # Dropping ManyToManyField 'Menu.translation'
        db.delete_table('menu_menu_translation')
        
        # Deleting field 'MenuTranslation.text'
        db.delete_column('menu_menutranslation', 'text')
        
        # Deleting field 'Menu.active'
        db.delete_column('menu_menu', 'active')
        
        # Creating unique_together for [language, menu] on MenuTranslation.
        db.create_unique('menu_menutranslation', ['language_id', 'menu_id'])
        
    
    
    def backwards(self, orm):
        
        # Deleting field 'MenuTranslation.menu'
        db.delete_column('menu_menutranslation', 'menu_id')
        
        # Deleting field 'MenuTranslation.caption'
        db.delete_column('menu_menutranslation', 'caption')
        
        # Adding ManyToManyField 'Menu.translation'
        db.create_table('menu_menu_translation', (
            ('id', models.AutoField(verbose_name='ID', primary_key=True, auto_created=True)),
            ('menu', models.ForeignKey(Menu, null=False)),
            ('menutranslation', models.ForeignKey(menutranslation, null=False))
        ))
        
        # Adding field 'MenuTranslation.text'
        db.add_column('menu_menutranslation', 'text', models.TextField(db_index=True, null=True, verbose_name=_('translated text'), blank=True))
        
        # Adding field 'Menu.active'
        db.add_column('menu_menu', 'active', models.BooleanField(default=True, verbose_name=_('is active'), db_index=True))
        
        # Deleting unique_together for [language, menu] on MenuTranslation.
        db.delete_unique('menu_menutranslation', ['language_id', 'menu_id'])
        
    
    
    models = {
        'i18n.language': {
            'Meta': {'ordering': "('name',)"},
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        },
        'menu.menutranslation': {
            'Meta': {'unique_together': "(('language','menu',),)"},
            'caption': ('models.CharField', [], {'max_length': '50', 'verbose_name': "_('translated caption')"}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'language': ('models.ForeignKey', ['Language'], {'verbose_name': "_('language')"}),
            'menu': ('models.ForeignKey', ['Menu'], {'verbose_name': "_('menu')"})
        },
        'template.template': {
            'Meta': {'ordering': "('name',)"},
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        },
        'menu.menu': {
            'caption': ('models.CharField', [], {'verbose_name': "_('caption')", 'max_length': '50', 'null': 'True', 'blank': 'True'}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'name': ('models.CharField', [], {'max_length': '50', 'verbose_name': "_('name for this node')", 'db_index': 'True'}),
            'open_choices': ('models.CharField', [], {'default': "'1'", 'max_length': '5', 'verbose_name': "_('open in')", 'db_index': 'True'}),
            'ordering': ('models.IntegerField', [], {'default': '0', 'verbose_name': "_('ordering')"}),
            'parent': ('models.ForeignKey', ["'self'"], {'related_name': "'children'", 'blank': 'True', 'null': 'True', 'verbose_name': "_('parent menu')", 'db_index': 'True'}),
            'permission': ('models.CharField', [], {'verbose_name': "_('permission')", 'max_length': '100', 'null': 'True', 'blank': 'True'}),
            'position': ('models.CharField', [], {'max_length': '5', 'blank': 'True', 'null': 'True', 'verbose_name': "_('position')"}),
            'slug': ('models.SlugField', [], {'db_index': 'True', 'verbose_name': "_('slug')", 'blank': 'True'}),
            'status': ('StatusField', [], {}),
            'template': ('models.ForeignKey', ['Template'], {'db_index': 'True', 'null': 'True', 'verbose_name': "_('template to render')", 'blank': 'True'}),
            'url': ('models.CharField', [], {'max_length': '256', 'blank': 'True', 'null': 'True', 'verbose_name': "_('url')", 'db_index': 'True'})
        },
        'menu.tmpmenutranslation': {
            'caption': ('models.CharField', [], {'max_length': '50', 'verbose_name': "_('translated caption')"}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'language': ('models.ForeignKey', ['Language'], {'verbose_name': "_('language')"}),
            'menu': ('models.ForeignKey', ['Menu'], {'verbose_name': "_('menu')"}),
            'text': ('models.TextField', [], {'blank': 'True', 'null': 'True', 'verbose_name': "_('translated text')", 'db_index': 'True'})
        }
    }
    
    complete_apps = ['menu']
