# -*- coding: utf-8 -*-

from south.db import db
from jumbo.db import HackForeignKey
from django.db import models
from jumbo.db.models import StatusField
from jumbo.apps.menu.models import *

class Migration:
    
    def forwards(self, orm):
        
        # Deleting model 'tmpmenutranslation'
        db.delete_table('menu_tmpmenutranslation')
        
    
    
    def backwards(self, orm):
        
        # Adding model 'tmpmenutranslation'
        db.create_table('menu_tmpmenutranslation', (
            ('language', models.ForeignKey(orm['i18n.language'], verbose_name=_('language'))),
            ('text', models.TextField(db_index=True, null=True, verbose_name=_('translated text'), blank=True)),
            ('caption', models.CharField(max_length=50, verbose_name=_('translated caption'))),
            ('menu', models.ForeignKey(orm.menu, verbose_name=_('menu'))),
            ('id', models.AutoField(primary_key=True)),
        ))
        db.send_create_signal('menu', ['tmpmenutranslation'])
        
    
    
    models = {
        'menu.menutranslation': {
            'Meta': {'unique_together': "(('language','menu',),)"},
            'caption': ('models.CharField', [], {'max_length': '50', 'verbose_name': "_('translated caption')"}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'language': ('models.ForeignKey', ['Language'], {'verbose_name': "_('language')"}),
            'menu': ('models.ForeignKey', ['Menu'], {'verbose_name': "_('menu')"})
        },
        'template.template': {
            'Meta': {'ordering': "('name',)"},
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        },
        'menu.menu': {
            'caption': ('models.CharField', [], {'verbose_name': "_('caption')", 'max_length': '50', 'null': 'True', 'blank': 'True'}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'name': ('models.CharField', [], {'max_length': '50', 'verbose_name': "_('name for this node')", 'db_index': 'True'}),
            'open_choices': ('models.CharField', [], {'default': "'1'", 'max_length': '5', 'verbose_name': "_('open in')", 'db_index': 'True'}),
            'ordering': ('models.IntegerField', [], {'default': '0', 'verbose_name': "_('ordering')"}),
            'parent': ('models.ForeignKey', ["'self'"], {'related_name': "'children'", 'blank': 'True', 'null': 'True', 'verbose_name': "_('parent menu')", 'db_index': 'True'}),
            'permission': ('models.CharField', [], {'verbose_name': "_('permission')", 'max_length': '100', 'null': 'True', 'blank': 'True'}),
            'position': ('models.CharField', [], {'max_length': '5', 'blank': 'True', 'null': 'True', 'verbose_name': "_('position')"}),
            'slug': ('models.SlugField', [], {'db_index': 'True', 'verbose_name': "_('slug')", 'blank': 'True'}),
            'status': ('StatusField', [], {}),
            'template': ('models.ForeignKey', ['Template'], {'db_index': 'True', 'null': 'True', 'verbose_name': "_('template to render')", 'blank': 'True'}),
            'url': ('models.CharField', [], {'max_length': '256', 'blank': 'True', 'null': 'True', 'verbose_name': "_('url')", 'db_index': 'True'})
        },
        'i18n.language': {
            'Meta': {'ordering': "('name',)"},
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        }
    }
    
    complete_apps = ['menu']
