# -*- coding: utf-8 -*-

from south.db import db
from jumbo.db import HackForeignKey
from django.db import models
from jumbo.db.models import StatusField
from jumbo.apps.menu.models import *

class Migration:
    
    def forwards(self, orm):
        
        # Adding model 'MenuIcon'
        db.create_table('menu_menuicon', (
            ('id', models.AutoField(primary_key=True)),
            ('menu', models.ForeignKey(orm.Menu, related_name='icons')),
            ('icon', models.ImageField(max_length=255)),
            ('type', models.CharField(max_length=20)),
            ('custom', models.CharField(max_length=20, null=True, blank=True)),
        ))
        db.send_create_signal('menu', ['MenuIcon'])
        
        # Changing field 'Category.last_modifier'
        db.alter_column('menu_category', 'last_modifier_id', models.ForeignKey(orm['auth.User'], db_index=True, null=True, blank=True))
        
        # Changing field 'Category.creator'
        db.alter_column('menu_category', 'creator_id', models.ForeignKey(orm['auth.User'], db_index=True, null=True, blank=True))
        
        # Changing field 'Category.ordering'
        db.alter_column('menu_category', 'ordering', models.IntegerField(default=0))
        
        # Changing field 'Category.date_create'
        db.alter_column('menu_category', 'date_create', models.DateTimeField())
        
        # Changing field 'Category.default'
        db.alter_column('menu_category', 'default', models.BooleanField(default=False))
        
        # Changing field 'Category.date_last_modify'
        db.alter_column('menu_category', 'date_last_modify', models.DateTimeField())
        
        # Changing field 'Category.name'
        db.alter_column('menu_category', 'name', models.CharField(max_length=25, unique=True))
        
        # Changing field 'MenuTranslation.caption'
        db.alter_column('menu_menutranslation', 'caption', models.CharField(max_length=50))
        
        # Changing field 'MenuTranslation.language'
        db.alter_column('menu_menutranslation', 'language_id', models.ForeignKey(orm['i18n.Language']))
        
        # Changing field 'MenuTranslation.menu'
        db.alter_column('menu_menutranslation', 'menu_id', models.ForeignKey(orm['menu.Menu']))
        
        # Changing field 'Menu.category'
        db.alter_column('menu_menu', 'category_id', models.ForeignKey(orm['menu.Category'], null=True, blank=True))
        
        # Changing field 'Menu.name'
        db.alter_column('menu_menu', 'name', models.CharField(max_length=50, db_index=True))
        
        # Changing field 'Menu.parent'
        db.alter_column('menu_menu', 'parent_id', models.ForeignKey(orm['menu.Menu'], blank=True, null=True, db_index=True))
        
        # Changing field 'Menu.permission'
        db.alter_column('menu_menu', 'permission', models.CharField(max_length=100, null=True, blank=True))
        
        # Changing field 'Menu.url'
        db.alter_column('menu_menu', 'url', models.CharField(max_length=256, blank=True, null=True, db_index=True))
        
        # Changing field 'Menu.open_choices'
        db.alter_column('menu_menu', 'open_choices', models.CharField(default='1', max_length=5, db_index=True))
        
        # Changing field 'Menu.slug'
        db.alter_column('menu_menu', 'slug', models.SlugField(db_index=True, blank=True))
        
        # Changing field 'Menu.ordering'
        db.alter_column('menu_menu', 'ordering', models.IntegerField(default=0))
        
        # Changing field 'Menu.template'
        db.alter_column('menu_menu', 'template_id', models.ForeignKey(orm['template.Template'], db_index=True, null=True, blank=True))
        
        # Changing field 'Menu.caption'
        db.alter_column('menu_menu', 'caption', models.CharField(max_length=50, null=True, blank=True))
        
        # Creating unique_together for [menu, type, custom] on MenuIcon.
        db.create_unique('menu_menuicon', ['menu_id', 'type', 'custom'])
        
    
    
    def backwards(self, orm):
        
        # Deleting model 'MenuIcon'
        db.delete_table('menu_menuicon')
        
        # Changing field 'Category.last_modifier'
        db.alter_column('menu_category', 'last_modifier_id', models.ForeignKey(orm['auth.User'], blank=True, null=True, db_index=True))
        
        # Changing field 'Category.creator'
        db.alter_column('menu_category', 'creator_id', models.ForeignKey(orm['auth.User'], blank=True, null=True, db_index=True))
        
        # Changing field 'Category.ordering'
        db.alter_column('menu_category', 'ordering', models.IntegerField(default=0))
        
        # Changing field 'Category.date_create'
        db.alter_column('menu_category', 'date_create', models.DateTimeField())
        
        # Changing field 'Category.default'
        db.alter_column('menu_category', 'default', models.BooleanField(default=False))
        
        # Changing field 'Category.date_last_modify'
        db.alter_column('menu_category', 'date_last_modify', models.DateTimeField())
        
        # Changing field 'Category.name'
        db.alter_column('menu_category', 'name', models.CharField(unique=True, max_length=25))
        
        # Changing field 'MenuTranslation.caption'
        db.alter_column('menu_menutranslation', 'caption', models.CharField(max_length=50))
        
        # Changing field 'MenuTranslation.language'
        db.alter_column('menu_menutranslation', 'language_id', models.ForeignKey(orm['i18n.Language']))
        
        # Changing field 'MenuTranslation.menu'
        db.alter_column('menu_menutranslation', 'menu_id', models.ForeignKey(orm.Menu))
        
        # Changing field 'Menu.category'
        db.alter_column('menu_menu', 'category_id', models.ForeignKey(orm.Category))
        
        # Changing field 'Menu.name'
        db.alter_column('menu_menu', 'name', models.CharField(max_length=50, db_index=True))
        
        # Changing field 'Menu.parent'
        db.alter_column('menu_menu', 'parent_id', models.ForeignKey(orm.Menu, db_index=True, null=True, blank=True))
        
        # Changing field 'Menu.permission'
        db.alter_column('menu_menu', 'permission', models.CharField(null=True, max_length=100, blank=True))
        
        # Changing field 'Menu.url'
        db.alter_column('menu_menu', 'url', models.CharField(db_index=True, max_length=256, null=True, blank=True))
        
        # Changing field 'Menu.open_choices'
        db.alter_column('menu_menu', 'open_choices', models.CharField(default='1', max_length=5, db_index=True))
        
        # Changing field 'Menu.slug'
        db.alter_column('menu_menu', 'slug', models.SlugField(blank=True, db_index=True))
        
        # Changing field 'Menu.ordering'
        db.alter_column('menu_menu', 'ordering', models.IntegerField(default=0))
        
        # Changing field 'Menu.template'
        db.alter_column('menu_menu', 'template_id', models.ForeignKey(orm['template.Template'], blank=True, null=True, db_index=True))
        
        # Changing field 'Menu.caption'
        db.alter_column('menu_menu', 'caption', models.CharField(null=True, max_length=50, blank=True))
        
        # Deleting unique_together for [menu, type, custom] on MenuIcon.
        db.delete_unique('menu_menuicon', ['menu_id', 'type', 'custom'])
        
    
    
    models = {
        'menu.menuicon': {
            'Meta': {'unique_together': "(('menu','type','custom',),)"},
            'custom': ('models.CharField', [], {'max_length': '20', 'null': 'True', 'blank': 'True'}),
            'icon': ('models.ImageField', [], {'max_length': '255'}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'menu': ('models.ForeignKey', ["orm['menu.Menu']"], {'related_name': "'icons'"}),
            'type': ('models.CharField', [], {'max_length': '20'})
        },
        'template.template': {
            'Meta': {'ordering': "('name',)"},
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        },
        'auth.user': {
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        },
        'menu.menutranslation': {
            'Meta': {'unique_together': "(('language','menu',),)"},
            'caption': ('models.CharField', [], {'max_length': '50'}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'language': ('models.ForeignKey', ["orm['i18n.Language']"], {}),
            'menu': ('models.ForeignKey', ["orm['menu.Menu']"], {'related_name': "'translations'"})
        },
        'menu.menu': {
            'caption': ('models.CharField', [], {'max_length': '50', 'null': 'True', 'blank': 'True'}),
            'category': ('models.ForeignKey', ["orm['menu.Category']"], {'related_name': "'menu'", 'null': 'True', 'blank': 'True'}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'name': ('models.CharField', [], {'max_length': '50', 'db_index': 'True'}),
            'open_choices': ('models.CharField', [], {'default': "'1'", 'max_length': '5', 'db_index': 'True'}),
            'ordering': ('models.IntegerField', [], {'default': '0'}),
            'parent': ('models.ForeignKey', ["orm['menu.Menu']"], {'related_name': "'children'", 'blank': 'True', 'null': 'True', 'db_index': 'True'}),
            'permission': ('models.CharField', [], {'max_length': '100', 'null': 'True', 'blank': 'True'}),
            'slug': ('models.SlugField', [], {'db_index': 'True', 'blank': 'True'}),
            'status': ('StatusField', [], {}),
            'template': ('models.ForeignKey', ["orm['template.Template']"], {'db_index': 'True', 'null': 'True', 'blank': 'True'}),
            'url': ('models.CharField', [], {'max_length': '256', 'blank': 'True', 'null': 'True', 'db_index': 'True'})
        },
        'i18n.language': {
            'Meta': {'ordering': "('name',)"},
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        },
        'menu.category': {
            'creator': ('HackForeignKey', ["orm['auth.User']"], {'db_index': 'True', 'related_name': '"%(app_label)s_%(class)s_creator"', 'null': 'True', 'blank': 'True'}),
            'date_create': ('models.DateTimeField', [], {}),
            'date_last_modify': ('models.DateTimeField', [], {}),
            'default': ('models.BooleanField', [], {'default': 'False'}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'last_modifier': ('HackForeignKey', ["orm['auth.User']"], {'db_index': 'True', 'related_name': "'%(app_label)s_%(class)s_last_modifier'", 'null': 'True', 'blank': 'True'}),
            'name': ('models.CharField', [], {'max_length': '25', 'unique': 'True'}),
            'ordering': ('models.IntegerField', [], {'default': '0'}),
            'status': ('StatusField', [], {})
        }
    }
    
    complete_apps = ['menu']
