# -*- coding: utf-8 -*-
'''
Created on 6/dic/2011

@author: simone cittadini
'''
import sys, logging, time
import hashlib, base64, md5

from suds.client import Client
from suds.xsd.doctor import Import, ImportDoctor
from suds.transport.http import HttpAuthenticated

from django.test import TestCase
from django.contrib.auth.models import User

from poste.webservice import ROLSoapClient, ROLSoapFactory, ExceptionPosteSoapClient

#from models import 

DEBUG = False
DEBUG = True
URL_TOL = 'http://sptest.posteitaliane.it/TelegrammaExtranet/WsTOL.svc?WSDL'
URL_ROL = 'http://sptest.posteitaliane.it/ROLGC/RolService.svc?WSDL'
URL_LOL = 'http://sptest.posteitaliane.it/LOLGC/LolService.svc?WSDL'


class TestPosteItalianeTOL(TestCase):
    """
    Casi di test che coprono il documento richiesto da poste italiane 
    per l'attivazione del canale h2h (telegramma).
    """
    
    def setUp(self):
        if DEBUG:
            logging.basicConfig(level=logging.INFO)
            logging.getLogger('suds.client').setLevel(logging.DEBUG)
            logging.getLogger('suds.transport').setLevel(logging.DEBUG)
        imp = Import('http://www.w3.org/2001/XMLSchema')
        imp.filter.add("http://ComunicazioniElettroniche.TOL.WS")
#        imp.filter.add("http://ComunicazioniElettroniche.Common.Schema.AbortOrderSchema")                                                                                                                                                            
#        imp.filter.add("http://ComunicazioniElettroniche.Common.Schema.ConfirmCaptureSchema")                                                                                                                                                                  
#        imp.filter.add("http://ComunicazioniElettroniche.Common.Schema.ConfirmRequestSchema")                                                                                                                                                                  
#        imp.filter.add("http://ComunicazioniElettroniche.Common.Schema.ConfirmResponseSchema")                                                                                                                                                                 
#        imp.filter.add("http://ComunicazioniElettroniche.Common.Schema.GenericSchema")                                                                                                                                                                
#        imp.filter.add("http://ComunicazioniElettroniche.Common.Schema.PreConfirmResponseSchema")                                                                                                                                                              
#        imp.filter.add("http://ComunicazioniElettroniche.Telegramma.Schema.TelegrammaSchema")                                                                                                                                                             
#        imp.filter.add("http://ComunicazioniElettroniche.Telegramma.WS")                                                                                                                                                                 
#        imp.filter.add("http://schemas.microsoft.com/2003/10/Serialization/")                                                                                                                                                                                  
#        imp.filter.add("http://schemas.microsoft.com/2003/10/Serialization/Arrays")  
        doctor = ImportDoctor(imp)
        self.c = Client(URL_TOL, doctor=doctor, username='H2HSTG21', password='Cestg021')
        self.c.set_options(location="http://sptest.posteitaliane.it/TelegrammaExtranet/WsTOL.svc")
        if DEBUG:
            print self.c
                
    def test_f0001_01(self):
        # verifica destinatario
        result = self.c.service.GetIdRequest()
        # recupero l'id richiesta
        idr = result
        # fornisco un destinatario valido e valorizzo nome e cognome
        r = self.c.factory.create('Recipient')
        r.destinatario.CAP = '20092'
        r.destinatario.Citta = 'CINISELLO BALSAMO'
        r.destinatario.Cognome = 'Cittadini'
        r.destinatario.Indirizzo = 'via casignolo, 4'
        r.destinatario.Nome = 'Simone'
        r.destinatario.RagioneSociale = ''
        r.destinatario.Stato = ''
        r.destinatario.Telefono = ''
        # verifico i destinatari
        result = self.c.service.RecipientValidation(recipient=r, idRequest=idr)
        self.assertEqual("I", result.Result.ResType)
        self.assertEqual("Address is valid", result.Result.Description )
        # sottometto il telegramma
        # ?
        
        
    def test_f0001_02(self):
        # verifica destinatario non valido
        result = self.c.service.GetIdRequest()
        # recupero l'id richiesta
        idr = result
        # fornisco un destinatario -non- valido e valorizzo nome e cognome
        r = self.c.factory.create('Recipient')
        r.destinatario.CAP = '20092'
        r.destinatario.Citta = 'CINISELLO BRONX'
        r.destinatario.Cognome = 'Cittadini'
        r.destinatario.Indirizzo = 'via casignolo, 4'
        r.destinatario.Nome = 'Simone'
        r.destinatario.RagioneSociale = ''
        r.destinatario.Stato = ''
        r.destinatario.Telefono = ''
        # verifico i destinatari
        result = self.c.service.RecipientValidation(recipient=r, idRequest=idr)
        self.assertEqual("E", result.Result.ResType)
        self.assertEqual("Unexpected error has occurred.The request has not been processed", result.Result.Description )
        # sottometto il telegramma
        # ?
    
    def test_f0001_03(self):
        # verifica destinatario  non valido
        result = self.c.service.GetIdRequest()
        # recuperto l'id richiesta
        idr = result
        # fornisco un destinatario con indirizzo valido e nome-cognome non valido
        r = self.c.factory.create('Recipient')
        r.destinatario.CAP = '20092'
        r.destinatario.Citta = 'CINISELLO BALSAMO'
        r.destinatario.Cognome = 'CittadiniCittadiniCittadiniCittadini'
        r.destinatario.Indirizzo = 'via casignolo, 4'
        r.destinatario.Nome = 'SimoneSimoneSimoneSimone'
        r.destinatario.RagioneSociale = ''
        r.destinatario.Stato = ''
        r.destinatario.Telefono = ''
        # verifico i destinatari
        result = self.c.service.RecipientValidation(recippient=r, idRequest=idr)
        self.assertEqual("E", result.Result.ResType)
        self.assertEqual("Unexpected error has occurred.The request has not been processed", result.Result.Description )
        # sottometto il telegramma
        # ?              
    
    def test_f0001_04(self):
        # verifica destinatario non valido
        result = self.c.service.GetIdRequest()
        # recupero l'id richiesta
        idr = result
        # fornisco un destinatario con indirizzo valido, nome-cognome valido e via non valida
        r = self.c.factory.create('Recipient')
        r.destinatario.CAP = '20092'
        r.destinatario.Citta = 'CINISELLO BALSAMO'
        r.destinatario.Cognome = 'Cittadini'
        r.destinatario.Indirizzo = 'via casignolo, 4 via casignolo, 4 via casignolo, 4 via casignolo, 4 via casignolo, 4 via casignolo, 4'
        r.destinatario.Nome = 'Simone'
        r.destinatario.RagioneSociale = ''
        r.destinatario.Stato = ''
        r.destinatario.Telefono = ''
        # verifico i destinatari
        result = self.c.service.RecipientValidation(recippient=r, idRequest=idr)
        self.assertEqual("E", result.Result.ResType)
        self.assertEqual("Unexpected error has occurred.The request has not been processed", result.Result.Description )
        # sottometto il telegramma
        # ?                 
    
    def test_f0001_05(self):
        # accettazione telegramma
        result = self.c.service.GetIdRequest()
        # recupero l'id richiesta
        idr = result
        # fornisco un destinatario valido
        r = self.c.factory.create('Recipient')
        r.destinatario.CAP = '15050'
        r.destinatario.Citta = 'PADERNA'
        r.destinatario.Cognome = 'Rossi'
        r.destinatario.Indirizzo = 'Via Roma 1'
        r.destinatario.Nome = 'Mario'
        r.destinatario.RagioneSociale = ''
        r.destinatario.Stato = ''
        r.destinatario.Telefono = ''
        # verifico i destinatari
        result = self.c.service.RecipientValidation(recipient=r, idRequest=idr)
        self.assertEqual("I", result.Result.ResType)
        self.assertEqual("Address is valid", result.Result.Description)
        # sottometto un telegramma con testo di 15 parole
        t = self.c.factory.create('Telegramma')
        print t           
    
    def test_f0001_06(self):
        # accettazione telegramma
        result = self.c.service.GetIdRequest()
        # reucpero l'ide richiesta
        idr = result
        # fornisco un destinatario valido
        r = self.c.factory.create('Recipient')
        r.destinatario.CAP = '15050'
        r.destinatario.Citta = 'PADERNA'
        r.destinatario.Cognome = 'Rossi'
        r.destinatario.Indirizzo = 'Via Roma 1'
        r.destinatario.Nome = 'Mario'
        r.destinatario.RagioneSociale = ''
        r.destinatario.Stato = ''
        r.destinatario.Telefono = ''      
         # verifico i destinatari
        result = self.c.service.RecipientValidation(recipient=r, idRequest=idr)
        self.assertEqual("I", result.Result.ResType)
        self.assertEqual("Address is valid", result.Result.Description)
        # sottometto un telegramma con testo di 25 parole
        t = self.c.factory.create('Telegramma')
        print t  
           
    def test_f0001_07(self):
        # accettazione telegramma multidestinatario
        result = self.c.service.GetIdRequest()
        # reucpero l'ide richiesta
        idr = result
        # fornisco un destinatario valido
        r1 = self.c.factory.create('Recipient')
        r1.destinatario.CAP = '15050'
        r1.destinatario.Citta = 'PADERNA'
        r1.destinatario.Cognome = 'Rossi'
        r1.destinatario.Indirizzo = 'Via Roma 1'
        r1.destinatario.Nome = 'Mario'
        r1.destinatario.RagioneSociale = ''
        r1.destinatario.Stato = ''
        r1.destinatario.Telefono = ''          
        # fornisco un secondo destinatario valido
        r2 = self.c.factory.create('Recipient')
        r2.destinatario.CAP = '20092'
        r2.destinatario.Citta = 'CINISELLO BALSAMO'
        r2.destinatario.Cognome = 'Cittadini'
        r2.destinatario.Indirizzo = 'Via Casignolo 4'
        r2.destinatario.Nome = 'Simone'
        r2.destinatario.RagioneSociale = ''
        r2.destinatario.Stato = ''
        r2.destinatario.Telefono = ''
        aor = self.c.factory.create('ArrayOfRecipient')
        aor.Recipient = (r1, r2)        
        # verifico i destinatari
        result = self.c.service.RecipientsValidation(recipients=aor, idRequest=idr)
        for rvr in result.RecipientValidationResult:
            self.assertEqual('Address is valid', rvr.Result.Description)
            self.assertEqual('I', rvr.Result.ResType)
        # sottometto un telegramma
        t = self.c.factory.create('Telegramma')
        print t          
            

    def test_f0001_08(self):
        # accettazione telegramma internazionale
        pass
    
    def test_f0001_09(self):
        # annulla operazione di invio
        result = self.c.service.GetIdRequest()
        # reucpero l'ide richiesta
        idr = result        
        # fornisco un destinatario valido
        r = self.c.factory.create('Recipient')
        r.destinatario.CAP = '15050'
        r.destinatario.Citta = 'PADERNA'
        r.destinatario.Cognome = 'Rossi'
        r.destinatario.Indirizzo = 'Via Roma 1'
        r.destinatario.Nome = 'Mario'
        r.destinatario.RagioneSociale = ''
        r.destinatario.Stato = ''
        r.destinatario.Telefono = ''
        # verifico i destinatari
        result = self.c.service.RecipientValidation(recipient=r, idRequest=idr)
        self.assertEqual("I", result.Result.ResType)
        self.assertEqual("Address is valid", result.Result.Description)
        # sottometto un telegramma con testo di 25 parole
        t = self.c.factory.create('Telegramma')
        print t            

class TestPosteItalianeROL(TestCase):
    """
    Casi di test che coprono il documento richiesto da poste italiane 
    per l'attivazione del canale h2h (raccomandata).
    """
    
    def setUp(self):
        if DEBUG:
            logging.basicConfig(level=logging.INFO)
            logging.getLogger('suds.client').setLevel(logging.DEBUG)
            logging.getLogger('suds.transport').setLevel(logging.DEBUG)
        imp = Import('http://www.w3.org/2001/XMLSchema')
        imp.filter.add("http://ComunicazioniElettroniche.ROL.WS")
        imp.filter.add("htp://ComunicazioniElettroniche.XOL")
        doctor = ImportDoctor(imp)
        self.c = Client(URL_ROL, doctor=doctor, username='H2HSTG21', password='Cestg021')
        self.c.set_options(location="http://sptest.posteitaliane.it/ROLGC/RolService.svc")
        self.filename = "./files/aquattro.pdf"
        if DEBUG:
            print self.c
        
    def test_f002_01(self):
        # verifica destinatario normale
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("Result OK", result.CEResult._Description)
        
        
    def test_f002_02(self):
        # verifica destinatario casella postale
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "CASELLA POSTALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "CASELLA POSTALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = "99999"
        nominativo._UfficioPostale = "milano 456"
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("Result OK", result.CEResult._Description)
        
    def test_f002_03(self):
        # destinatario errato
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "CASELLA POSTALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = "99999"
        nominativo._UfficioPostale = "milano 456"
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("W", result.CEResult._Type)
        self.assertEqual("alcuni indirizzi ambigui o non validi", result.CEResult._Description)
        self.assertEqual("0034", result.CEResult._Code)
        
    def test_f002_04(self):
        # destinatario normale errato
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario non valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANEITALIANEITALIANEITALIANEITALIANEITALIANE"
        nominativo._Nome = "POSTEPOSTEPOSTEPOSTEPOSTEPOSTEPOSTEPOSTEPOSTEPOSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("E", result.CEResult._Type)
        self.assertEqual("la lunghezza di nome + cognome + rag. sociale eccede quella prevista", result.CEResult._Description)
        self.assertEqual("1051", result.CEResult._Code)
                
    def test_f002_05(self):
        # destinatario normale errato
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALEVIALEVIALEVIALEVIALEVIALEVIALEVIALEVIALEVIALE'
        indirizzo._Toponimo = 'EUROPAEUROPAEUROPAEUROPAEUROPAEUROPAEUROPAEUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("E", result.CEResult._Type)
        self.assertEqual("la lunghezza di dug + toponimo + num. civico + esponente eccede quella prevista", result.CEResult._Description)
        self.assertEqual("1050", result.CEResult._Code)
                
    def test_f002_06(self):
        # destinatario normale errato
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = "                                               "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CIDEST CIDEST CIDEST CIDEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("E", result.CEResult._Type)
        self.assertEqual("la lunghezza della frazione eccede quella prevista", result.CEResult._Description)
        self.assertEqual("1059", result.CEResult._Code)
                
    def test_f002_07(self):
        # destinatario normale errato
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("E", result.CEResult._Type)
        self.assertEqual("la lunghezza di complemento nominativo eccede quella prevista", result.CEResult._Description)
        self.assertEqual("1053", result.CEResult._Code)

    def test_f002_08(self):
        # destinatario casella postale errato
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "CASELLA POSTALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = "99999"
        nominativo._UfficioPostale = "milano 456milano 456milano 456milano 456milano 456milano 456milano 456milano 456milano 456milano 456milano 456"
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("E", result.CEResult._Type)
        self.assertEqual("la lunghezza dell'ufficio postale eccede quella prevista", result.CEResult._Description)
        self.assertEqual("1054", result.CEResult._Code)
                
    def test_f002_09(self):
        # invio normale
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("Result OK", result.CEResult._Description)
        # invio un documento pdf valido
        indirizzo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo_mittente._DUG = 'VIA'
        indirizzo_mittente._Toponimo = 'DANTE ALIGHIERI'
        indirizzo_mittente._NumeroCivico = '99'
        indirizzo_mittente._Esponente = " "
        nominativo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo_mittente.Indirizzo = indirizzo_mittente
        nominativo_mittente._Zona = " "
        nominativo_mittente._TipoIndirizzo = "NORMALE"
        nominativo_mittente._Stato = "Italia"
        nominativo_mittente._Telefono = " "
        nominativo_mittente._ForzaDestinazione = "false"
        nominativo_mittente._CasellaPostale = " "
        nominativo_mittente._UfficioPostale = " "
        nominativo_mittente._Provincia = "MI"
        nominativo_mittente._ComplementoNominativo = "DEST CN"
        nominativo_mittente._RagioneSociale = " "
        nominativo_mittente._Cognome = "SYSTEMS"
        nominativo_mittente._Nome = "THUNDER"
        nominativo_mittente._Frazione = " "
        nominativo_mittente._Citta = "LIMITO DI PIOLTELLO"
        nominativo_mittente._ComplementoIndirizzo = "DEST CI"
        nominativo_mittente._CAP = "20096"        
        mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Mittente')
        mittente.Nominativo = nominativo_mittente
        rs = self.c.factory.create('ROLSubmit')
        rs.Mittente = mittente
#        aod = self.c.factory.create('ArrayOfDestinatario')
#        aod.Destinatario.append(destinatario)
        rs.Destinatari = aod
        rs.NumeroDestinatari = "1"
        
        encoded_data = base64.b64encode(open(self.filename, 'rb').read())
        strg = ''
        for i in xrange((len(encoded_data)/40)+1):
            strg += encoded_data[i*40:(i+1)*40]
        img = strg
        emmedic = md5.new(file(self.filename).read()).hexdigest()
        
        opzioni = self.c.factory.create('Opzioni')
        opzioni._SecurPaper = "false"
        opzioni._InserisciMittente = "false"
        opzioni._DataStampa = "2011-12-14T09:00:00.00000+02:00"
        opzioni._FirmaElettronica = "false"
        opzioni._Archiviazione = "false"
        opzioni._DPM = "false"
        inserti = self.c.factory.create('Inserti')
        inserti._InserisciMittente = 'false'
        inserti._Inserto = " "
        opzioni.Inserti = inserti
        documento = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Documento')
        documento.Firmatari = " "
        documento.Immagine = img
        documento.MD5 = emmedic.upper()
        documento._TipoDocumento = "pdf"
        rs.Documento = documento
        rs.Opzioni = opzioni
        testatacover = self.c.factory.create('TestataCover')
        testatacover.Logo = " "
        aosf = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}ArrayOfString5')
        aosf.TestoCL = []
        testatacover.ChiusuraLettera = aosf
        result = self.c.service.Invio(IDRichiesta=idr,
                                      Cliente="NPCE Client Test",
                                      ROLSubmit=rs)
        # recupero lo stato
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)

               
    def test_f002_10(self):
        # invio a casella postale
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "CASELLA POSTALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = "99999"
        nominativo._UfficioPostale = "milano 456"
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("Result OK", result.CEResult._Description)
        # invio un documento pdf valido
        indirizzo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo_mittente._DUG = 'VIA'
        indirizzo_mittente._Toponimo = 'DANTE ALIGHIERI'
        indirizzo_mittente._NumeroCivico = '99'
        indirizzo_mittente._Esponente = " "
        nominativo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo_mittente.Indirizzo = indirizzo_mittente
        nominativo_mittente._Zona = " "
        nominativo_mittente._TipoIndirizzo = "NORMALE"
        nominativo_mittente._Stato = "Italia"
        nominativo_mittente._Telefono = " "
        nominativo_mittente._ForzaDestinazione = "false"
        nominativo_mittente._CasellaPostale = " "
        nominativo_mittente._UfficioPostale = " "
        nominativo_mittente._Provincia = "MI"
        nominativo_mittente._ComplementoNominativo = "DEST CN"
        nominativo_mittente._RagioneSociale = " "
        nominativo_mittente._Cognome = "SYSTEMS"
        nominativo_mittente._Nome = "THUNDER"
        nominativo_mittente._Frazione = " "
        nominativo_mittente._Citta = "LIMITO DI PIOLTELLO"
        nominativo_mittente._ComplementoIndirizzo = "DEST CI"
        nominativo_mittente._CAP = "20096"        
        mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Mittente')
        mittente.Nominativo = nominativo_mittente
        rs = self.c.factory.create('ROLSubmit')
        rs.Mittente = mittente
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        rs.Destinatari = aod
        rs.NumeroDestinatari = "1"

        encoded_data = base64.b64encode(open(self.filename, 'rb').read())
        strg = ''
        for i in xrange((len(encoded_data)/40)+1):
            strg += encoded_data[i*40:(i+1)*40]
        img = strg
        emmedic = md5.new(file(self.filename).read()).hexdigest()
        
        opzioni = self.c.factory.create('Opzioni')
        opzioni._SecurPaper = "false"
        opzioni._InserisciMittente = "false"
        opzioni._DataStampa = "2011-12-14T09:00:00.00000+02:00"
        opzioni._FirmaElettronica = "false"
        opzioni._Archiviazione = "false"
        opzioni._DPM = "false"
        inserti = self.c.factory.create('Inserti')
        inserti._InserisciMittente = 'false'
        inserti._Inserto = " "
        opzioni.Inserti = inserti
        documento = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Documento')
        documento.Firmatari = " "
        documento.Immagine = img
        documento.MD5 = emmedic.upper()
        documento._TipoDocumento = "pdf"
        rs.Documento = documento
        rs.Opzioni = opzioni
        testatacover = self.c.factory.create('TestataCover')
        testatacover.Logo = " "
        aosf = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}ArrayOfString5')
        aosf.TestoCL = []
        testatacover.ChiusuraLettera = aosf
        result = self.c.service.Invio(IDRichiesta=idr,
                                      Cliente="NPCE Client Test",
                                      ROLSubmit=rs)
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)
        # recupero lo stato
        result = self.c.service.RecuperaStatoIdRichiesta(IdRichiesta=result.IDRichiesta)
        print result
        
    def test_f002_11(self):
        # invio normale
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("Result OK", result.CEResult._Description)
        # invio un documento pdf valido
        indirizzo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo_mittente._DUG = 'VIA'
        indirizzo_mittente._Toponimo = 'DANTE ALIGHIERI'
        indirizzo_mittente._NumeroCivico = '99'
        indirizzo_mittente._Esponente = " "
        nominativo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo_mittente.Indirizzo = indirizzo_mittente
        nominativo_mittente._Zona = " "
        nominativo_mittente._TipoIndirizzo = "NORMALE"
        nominativo_mittente._Stato = "Italia"
        nominativo_mittente._Telefono = " "
        nominativo_mittente._ForzaDestinazione = "false"
        nominativo_mittente._CasellaPostale = " "
        nominativo_mittente._UfficioPostale = " "
        nominativo_mittente._Provincia = "MI"
        nominativo_mittente._ComplementoNominativo = "DEST CN"
        nominativo_mittente._RagioneSociale = " "
        nominativo_mittente._Cognome = "SYSTEMS"
        nominativo_mittente._Nome = "THUNDER"
        nominativo_mittente._Frazione = " "
        nominativo_mittente._Citta = "LIMITO DI PIOLTELLO"
        nominativo_mittente._ComplementoIndirizzo = "DEST CI"
        nominativo_mittente._CAP = "20096"        
        mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Mittente')
        mittente.Nominativo = nominativo_mittente
        rs = self.c.factory.create('ROLSubmit')
        rs.Mittente = mittente
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        rs.Destinatari = aod
        rs.NumeroDestinatari = "1"

        encoded_data = base64.b64encode(open(self.filename, 'rb').read())
        img = encoded_data
        m = md5.new()
        m.update(img)
        emmedic = m.hexdigest()
        
        documento = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Documento')
        documento.Firmatari = " "
        documento.Immagine = img
        documento.MD5 = emmedic.upper()
        documento._TipoDocumento = "pdf"
        rs.Documento = documento
        result = self.c.service.Invio(IDRichiesta=idr, Cliente="1", ROLSubmit=rs)
        # recupero lo stato
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)
        # recupero il documento convertito
        richiesta = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Richiesta')
        richiesta.IDRichiesta = result.IDRichiesta
        richiesta.GuidUtente = result.GuidUtente
        result = self.c.service.RecuperaDCS(Richiesta=richiesta)
        print result
                
    def test_f002_12(self):
        # invio pdf con formato maggiore di A4
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("Result OK", result.CEResult._Description)
        # invio un documento pdf valido
        indirizzo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo_mittente._DUG = 'VIA'
        indirizzo_mittente._Toponimo = 'DANTE ALIGHIERI'
        indirizzo_mittente._NumeroCivico = '99'
        indirizzo_mittente._Esponente = " "
        nominativo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo_mittente.Indirizzo = indirizzo_mittente
        nominativo_mittente._Zona = " "
        nominativo_mittente._TipoIndirizzo = "NORMALE"
        nominativo_mittente._Stato = "Italia"
        nominativo_mittente._Telefono = " "
        nominativo_mittente._ForzaDestinazione = "false"
        nominativo_mittente._CasellaPostale = " "
        nominativo_mittente._UfficioPostale = " "
        nominativo_mittente._Provincia = "MI"
        nominativo_mittente._ComplementoNominativo = "DEST CN"
        nominativo_mittente._RagioneSociale = " "
        nominativo_mittente._Cognome = "SYSTEMS"
        nominativo_mittente._Nome = "THUNDER"
        nominativo_mittente._Frazione = " "
        nominativo_mittente._Citta = "LIMITO DI PIOLTELLO"
        nominativo_mittente._ComplementoIndirizzo = "DEST CI"
        nominativo_mittente._CAP = "20096"        
        mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Mittente')
        mittente.Nominativo = nominativo_mittente
        rs = self.c.factory.create('ROLSubmit')
        rs.Mittente = mittente
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        rs.Destinatari = aod
        rs.NumeroDestinatari = "1"

        encoded_data = base64.b64encode(open(self.filename, 'rb').read())
        img = encoded_data
        m = md5.new()
        m.update(img)
        emmedic = m.hexdigest()
        
        documento = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Documento')
        documento.Firmatari = " "
        documento.Immagine = img
        documento.MD5 = emmedic.upper()
        documento._TipoDocumento = "pdf"
        rs.Documento = documento
        result = self.c.service.Invio(IDRichiesta=idr, Cliente="1", ROLSubmit=rs)
        # recupero lo stato
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)
        # recupero il documento convertito
        richiesta = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Richiesta')
        richiesta.IDRichiesta = result.IDRichiesta
        richiesta.GuidUtente = result.GuidUtente
        result = self.c.service.RecuperaDCS(Richiesta=richiesta)
        print result
               
    def test_f002_13(self):
        # annulla operazione di invio
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("Result OK", result.CEResult._Description)
        # invio un documento pdf valido
        indirizzo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo_mittente._DUG = 'VIA'
        indirizzo_mittente._Toponimo = 'DANTE ALIGHIERI'
        indirizzo_mittente._NumeroCivico = '99'
        indirizzo_mittente._Esponente = " "
        nominativo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo_mittente.Indirizzo = indirizzo_mittente
        nominativo_mittente._Zona = " "
        nominativo_mittente._TipoIndirizzo = "NORMALE"
        nominativo_mittente._Stato = "Italia"
        nominativo_mittente._Telefono = " "
        nominativo_mittente._ForzaDestinazione = "false"
        nominativo_mittente._CasellaPostale = " "
        nominativo_mittente._UfficioPostale = " "
        nominativo_mittente._Provincia = "MI"
        nominativo_mittente._ComplementoNominativo = "DEST CN"
        nominativo_mittente._RagioneSociale = " "
        nominativo_mittente._Cognome = "SYSTEMS"
        nominativo_mittente._Nome = "THUNDER"
        nominativo_mittente._Frazione = " "
        nominativo_mittente._Citta = "LIMITO DI PIOLTELLO"
        nominativo_mittente._ComplementoIndirizzo = "DEST CI"
        nominativo_mittente._CAP = "20096"        
        mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Mittente')
        mittente.Nominativo = nominativo_mittente
        rs = self.c.factory.create('ROLSubmit')
        rs.Mittente = mittente
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        rs.Destinatari = aod
        rs.NumeroDestinatari = "1"

        encoded_data = base64.b64encode(open(self.filename, 'rb').read())
        img = encoded_data
        m = md5.new()
        m.update(img)
        emmedic = m.hexdigest()
        
        documento = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Documento')
        documento.Firmatari = " "
        documento.Immagine = img
        documento.MD5 = emmedic.upper()
        documento._TipoDocumento = "pdf"
        rs.Documento = documento
        result = self.c.service.Invio(IDRichiesta=idr, Cliente="1", ROLSubmit=rs)
        # recupero lo stato
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)
        # annullo l'invio
        richiesta = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Richiesta')
        richiesta.IDRichiesta = result.IDRichiesta
        richiesta.GuidUtente = result.GuidUtente
        self.c.service.Annulla(AnnullaRequest=richiesta)
                
    def test_f002_14(self):
        ## conferma invio normale
        # recupero l'id richiesta
        result = self.c.service.RecuperaIdRichiesta()
        self.assertEqual("0000", result.CEResult._Code)
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        indirizzo = self.c.factory.create(
                            '{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo._DUG = 'VIALE'
        indirizzo._Toponimo = 'EUROPA'
        indirizzo._NumeroCivico = '175'
        indirizzo._Esponente = " "
        nominativo = self.c.factory.create(
                            '{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo.Indirizzo = indirizzo
        nominativo._Zona = " "
        nominativo._TipoIndirizzo = "NORMALE"
        nominativo._Stato = "Italia"
        nominativo._Telefono = " "
        nominativo._ForzaDestinazione = "false"
        nominativo._CasellaPostale = " "
        nominativo._UfficioPostale = " "
        nominativo._Provincia = "RM"
        nominativo._ComplementoNominativo = "DEST CN"
        nominativo._RagioneSociale = " "
        nominativo._Cognome = "ITALIANE"
        nominativo._Nome = "POSTE"
        nominativo._Frazione = " "
        nominativo._Citta = "ROMA"
        nominativo._ComplementoIndirizzo = "DEST CI"
        nominativo._CAP = "00144"
        destinatario = self.c.factory.create(
                        '{http://ComunicazioniElettroniche.XOL}Destinatario')
        destinatario.Nominativo = nominativo
        destinatario._IdRicevuta = " "
        destinatario._IdDestinatario = "1"
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr,
                                                  Destinatari=aod)
        self.assertEqual("I", result.CEResult._Type)
        self.assertEqual("0000", result.CEResult._Code)
        # invio un documento pdf valido
        indirizzo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Indirizzo')
        indirizzo_mittente._DUG = 'VIA'
        indirizzo_mittente._Toponimo = 'DANTE ALIGHIERI'
        indirizzo_mittente._NumeroCivico = '99'
        indirizzo_mittente._Esponente = " "
        nominativo_mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Nominativo')
        nominativo_mittente.Indirizzo = indirizzo_mittente
        nominativo_mittente._Zona = " "
        nominativo_mittente._TipoIndirizzo = "NORMALE"
        nominativo_mittente._Stato = "Italia"
        nominativo_mittente._Telefono = " "
        nominativo_mittente._ForzaDestinazione = "false"
        nominativo_mittente._CasellaPostale = " "
        nominativo_mittente._UfficioPostale = " "
        nominativo_mittente._Provincia = "MI"
        nominativo_mittente._ComplementoNominativo = "DEST CN"
        nominativo_mittente._RagioneSociale = " "
        nominativo_mittente._Cognome = "SYSTEMS"
        nominativo_mittente._Nome = "THUNDER"
        nominativo_mittente._Frazione = " "
        nominativo_mittente._Citta = "LIMITO DI PIOLTELLO"
        nominativo_mittente._ComplementoIndirizzo = "DEST CI"
        nominativo_mittente._CAP = "20096"        
        mittente = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Mittente')
        mittente._InviaStampa = 'false'
        mittente.Nominativo = nominativo_mittente
        rs = self.c.factory.create('ROLSubmit')
        rs._ForzaInvioDestinazioniValide = 'false'
        rs.Mittente = mittente
        aod = self.c.factory.create('ArrayOfDestinatario')
        aod.Destinatario.append(destinatario)
        rs.Destinatari = aod
        rs.NumeroDestinatari = "1"

        encoded_data = base64.b64encode(open(self.filename, 'rb').read())
        strg = ''
        for i in xrange((len(encoded_data)/40)+1):
            strg += encoded_data[i*40:(i+1)*40]
        img = strg
        emmedic = md5.new(file(self.filename).read()).hexdigest()

        opzioni = self.c.factory.create('Opzioni')
        opzioni._SecurPaper = "false"
        opzioni._InserisciMittente = "false"
        opzioni._DataStampa = "2011-12-14T09:00:00.00000+02:00"
        opzioni._FirmaElettronica = "false"
        opzioni._Archiviazione = "false"
        opzioni._DPM = "false"
        inserti = self.c.factory.create('Inserti')
        inserti._InserisciMittente = 'false'
        inserti._Inserto = " "
        opzioni.Inserti = inserti
        documento = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Documento')
        documento.Firmatari = " "
        documento.Immagine = img
        documento.MD5 = emmedic.upper()
        documento._TipoDocumento = "pdf"
        rs.Documento = documento
        rs.Opzioni = opzioni
        testatacover = self.c.factory.create('TestataCover')
        testatacover.Logo = " "
        aosf = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}ArrayOfString5')
        aosf.TestoCL = []
        testatacover.ChiusuraLettera = aosf
#        rs.TestataCover = testatacover
        result = self.c.service.Invio(IDRichiesta=idr,
                                      Cliente="NPCE Client Test",
                                      ROLSubmit=rs)
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)
        # valorizzo
        ric = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Richiesta')
        ric.IDRichiesta = result.IDRichiesta
        ric.GuidUtente = result.GuidUtente
        
        status = 'INIT'
        while status != 'R' and status != 'N':
            time.sleep(35)
            result = self.c.service.Valorizza(Richieste=[ric, ])
            status = result[0][0].StatoLavorazione._Id
        if status == 'N':
            self.fail('stato N dal server di poste')
        
        # preconfermo
        preconfermareq = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}Richiesta')
        preconfermareq.IDRichiesta = result.ServizioEnquiryResponse[0].Richiesta.IDRichiesta
        preconfermareq.GuidUtente = result.ServizioEnquiryResponse[0].Richiesta.GuidUtente
        result = self.c.service.PreConferma(Richieste=preconfermareq,
                                            autoConferma="false")
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)
        # conferma
        op = result.Valorizzazione.OpzionePagamento[0]
        dt = self.c.factory.create('{http://ComunicazioniElettroniche.XOL}DatiTransazione')
        result = self.c.service.Conferma(IdOrdine=result.IdOrdine,
                                         OpzionePagamento=op,
                                         DatiTransazione=dt)
        self.assertEqual('0000', result.CEResult._Code)
        self.assertEqual('I', result.CEResult._Type)
                
    def test_f002_15(self):
        # conferma invio a casella postale
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        aod = self.c.factory.create('ArrayOfDestinatario')
        d = self.c.factory.create('ns1:Destinatario')
        d.Nominativo._CAP = "20092"
        d.Nominativo._Citta = "CINISELLO BALSAMO"
        d.Nominativo._Provincia = "MI"
        d.Nominativo._Nome = "Simone"
        d.Nominativo._Cognome = "Cittadini"
        d.Nominativo.CasellaPostale = ""
        d.Nominativo.UfficioPostale = ""
        d.Nominativo.RagioneSociale = ""
        d.Nominativo._TipoIndirizzo = "CASELLA POSTALE"
        aod.Destinatario = [d,]
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        print result  
        
    def test_f002_16(self):
        # conferma invio normale multidestinatario
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        aod = self.c.factory.create('ArrayOfDestinatario')
        d1 = self.c.factory.create('ns1:Destinatario')
        d1.Nominativo._CAP = "20092"
        d1.Nominativo._Citta = "CINISELLO BALSAMO"
        d1.Nominativo._Provincia = "MI"
        d1.Nominativo._Nome = "Simone"
        d1.Nominativo._Cognome = "Cittadini"
        d1.Nominativo.Indirizzo._DUG = "Via"
        d1.Nominativo.Indirizzo._Toponimo = "Casignolo"
        d1.Nominativo.Indirizzo._NumeroCivico = "4"
        d1.Nominativo._TipoIndirizzo = "NORMALE"
        d2 = self.c.factory.create('ns1:Destinatario')
        d2.Nominativo._CAP = "15050"
        d2.Nominativo._Citta = "PADERNA"
        d2.Nominativo._Provincia = "AL"
        d2.Nominativo._Nome = "Mario"
        d2.Nominativo._Cognome = "Rossi"
        d2.Nominativo.Indirizzo._DUG = "Via"
        d2.Nominativo.Indirizzo._Toponimo = "Roma"
        d2.Nominativo.Indirizzo._NumeroCivico = "1"
        d2.Nominativo._TipoIndirizzo = "NORMALE"     
        aod.Destinatario = [d1, d2]
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        print result
                
    def test_f002_17(self):
        # conferma invio normale con ricevuta di ritorno
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        aod = self.c.factory.create('ArrayOfDestinatario')
        d = self.c.factory.create('ns1:Destinatario')
        d.Nominativo._CAP = "20092"
        d.Nominativo._Citta = "CINISELLO BALSAMO"
        d.Nominativo._Provincia = "MI"
        d.Nominativo._Nome = "Simone"
        d.Nominativo._Cognome = "Cittadini"
        d.Nominativo.Indirizzo._DUG = "Via"
        d.Nominativo.Indirizzo._Toponimo = "Casignolo"
        d.Nominativo.Indirizzo._NumeroCivico = "4"
        d.Nominativo._TipoIndirizzo = "NORMALE"
        aod.Destinatario = [d,]
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        print result
        
class TestPosteItalianeLOL(TestCase):
    """
    Casi di test che coprono il documento richiesto da poste italiane 
    per l'attivazione del canale h2h (lettera).
    """
    
    def setUp(self):
        if DEBUG:
            logging.basicConfig(level=logging.INFO)
            logging.getLogger('suds.client').setLevel(logging.DEBUG)
            logging.getLogger('suds.transport').setLevel(logging.DEBUG)
        imp = Import('http://www.w3.org/2001/XMLSchema')
        imp.filter.add("http://ComunicazioniElettroniche.LOL.WS")
        imp.filter.add("http://ComunicazioniElettroniche.XOL")
        doctor = ImportDoctor(imp)
        self.c = Client(URL_LOL, doctor=doctor, username='H2HSTG21', password='Cestg021')
        self.c.set_options(location="http://sptest.posteitaliane.it/LOLGC/LolService.svc")
        if DEBUG:
            print self.c
            
    def test_f003_01(self):
        # verifica destinatario normale
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        self.assertEqual("I", result.CEResult._Type)
        idr = result.IDRichiesta
        # fornisco un destinatario valido con tipo indirizzo "NORMALE"
        aod = self.c.factory.create('ArrayOfDestinatario')
        d = self.c.factory.create('ns1:Destinatario')
        d.Nominativo._CAP = "20092"
        d.Nominativo._Citta = "CINISELLO BALSAMO"
        d.Nominativo._Provincia = "MI"
        d.Nominativo._Nome = "Simone"
        d.Nominativo._Cognome = "Cittadini"
        d.Nominativo.Indirizzo._DUG = "Via"
        d.Nominativo.Indirizzo._Toponimo = "Casignolo"
        d.Nominativo.Indirizzo._NumeroCivico = "4"
        d.Nominativo._TipoIndirizzo = "NORMALE"
        aod.Destinatario = [d,]
        # eseguo valida destinatari
        result = self.c.service.ValidaDestinatari(IDRichiesta=idr, Destinatari=aod)
        print result
    
        
    def test_f003_02(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_03(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_04(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
    
    def test_f003_05(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_06(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   

    def test_f003_07(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_08(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_09(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_10(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_11(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_12(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_13(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_14(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_15(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta   
        
    def test_f003_16(self):
        result = self.c.service.RecuperaIdRichiesta()
        # recupero l'id richiesta
        
class TestPosteWebservice(TestCase):
    
    def setUp(self):
        self.s = ROLSoapClient()
        self.f = ROLSoapFactory()
        self.filename = "./files/aquattro.pdf"
    
    def test_rol_01(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                  toponimo='EUROPA',
                                  numero_civico='75',
                                  tipo_indirizzo='NORMALE',
                                  stato='ITALIA',
                                  forza_destinazione='false',
                                  provincia='RM',
                                  complemento_nominativo='DEST CN',
                                  cognome='ITALIANE',
                                  nome='POSTE',
                                  citta='ROMA',
                                  complemento_indirizzo='DEST CI',
                                  cap='00144',
                                  id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        result = self.s.valida_destinatari(idr, aod)
        
    def test_rol_02(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                     toponimo='EUROPA',
                                     numero_civico='175',
                                     tipo_indirizzo='CASELLA POSTALE',
                                     stato='Italia',
                                     forza_destinazione='false',
                                     casella_postale='99999',
                                     ufficio_postale='milano 456',
                                     provincia='RM',
                                     complemento_nominativo='DEST CN',
                                     cognome='ITALIANE',
                                     nome='POSTE',
                                     citta='ROMA',
                                     complemento_indirizzo='DEST CI',
                                     cap='00144',
                                     id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        result = self.s.valida_destinatari(idr, aod)
        
    def test_rol_03(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                     toponimo='EUROPA',
                                     numero_civico='175',
                                     tipo_indirizzo='CASELLA POSTALE',
                                     stato='Italia',
                                     forza_destinazione='false',
                                     casella_postale='99999',
                                     ufficio_postale='milano 456',
                                     provincia='RM',
                                     complemento_nominativo='DEST CN',
                                     cognome='ITALIANE',
                                     nome='POSTE',
                                     citta='ROMA',
                                     complemento_indirizzo='DEST CI',
                                     cap='00',
                                     id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.assertRaises(ExceptionPosteSoapClient, self.s.valida_destinatari,
                          idr, aod)

    def test_rol_04(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                  toponimo='EUROPA',
                                  numero_civico='75',
                                  tipo_indirizzo='NORMALE',
                                  stato='ITALIA',
                                  forza_destinazione='false',
                                  provincia='RM',
                                  complemento_nominativo='DEST CN',
                                  cognome='ITALIANEITALIANEITALIANEITALIANEITALIANEITALIANEITALIANE',
                                  nome='POSTEPOSTEPOSTEPOSTEPOSTEPOSTEPOSTEPOSTEPOSTE',
                                  citta='ROMA',
                                  complemento_indirizzo='DEST CI',
                                  cap='00144',
                                  id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.assertRaises(ExceptionPosteSoapClient, self.s.valida_destinatari,
                          idr, aod)
        
    def test_rol_05(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALEVIALEVIALEVIALEVIALEVIALEVIALEVIALE',
                                     toponimo='EUROPAEUROPAEUROPAEUROPAEUROPAEUROPAEUROPA',
                                     numero_civico='175',
                                     tipo_indirizzo='CASELLA POSTALE',
                                     stato='Italia',
                                     forza_destinazione='false',
                                     casella_postale='99999',
                                     ufficio_postale='milano 456',
                                     provincia='RM',
                                     complemento_nominativo='DEST CN',
                                     cognome='ITALIANE',
                                     nome='POSTE',
                                     citta='ROMA',
                                     complemento_indirizzo='DEST CI',
                                     cap='00144',
                                     id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.assertRaises(ExceptionPosteSoapClient, self.s.valida_destinatari,
                          idr, aod)
        
    def test_rol_06(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                  toponimo='EUROPA',
                                  numero_civico='75',
                                  tipo_indirizzo='NORMALE',
                                  stato='ITALIA',
                                  forza_destinazione='false',
                                  provincia='RM',
                                  complemento_nominativo='DEST CN',
                                  cognome='ITALIANE',
                                  nome='POSTE',
                                  citta='ROMA',
                                  complemento_indirizzo='DEST CIDEST CIDEST CIDEST CIDEST CIDEST CIDEST CIDEST CIDEST CIDEST CIDEST CI',
                                  cap='00144',
                                  id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.assertRaises(ExceptionPosteSoapClient, self.s.valida_destinatari,
                          idr, aod)
        
    def test_rol_07(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                  toponimo='EUROPA',
                                  numero_civico='75',
                                  tipo_indirizzo='NORMALE',
                                  stato='ITALIA',
                                  forza_destinazione='false',
                                  provincia='RM',
                                  complemento_nominativo='DEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CNDEST CN',
                                  cognome='ITALIANE',
                                  nome='POSTE',
                                  citta='ROMA',
                                  complemento_indirizzo='DEST CI',
                                  cap='00144',
                                  id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.assertRaises(ExceptionPosteSoapClient, self.s.valida_destinatari,
                          idr, aod)
        
    def test_rol_08(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                     toponimo='EUROPA',
                                     numero_civico='175',
                                     tipo_indirizzo='CASELLA POSTALE',
                                     stato='Italia',
                                     forza_destinazione='false',
                                     casella_postale='99999',
                                     ufficio_postale='milano 456milano 456milano 456milano 456milano 456',
                                     provincia='RM',
                                     complemento_nominativo='DEST CN',
                                     cognome='ITALIANE',
                                     nome='POSTE',
                                     citta='ROMA',
                                     complemento_indirizzo='DEST CI',
                                     cap='00144',
                                     id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.assertRaises(ExceptionPosteSoapClient, self.s.valida_destinatari,
                          idr, aod)
        
    def test_rol_09(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                  toponimo='EUROPA',
                                  numero_civico='75',
                                  tipo_indirizzo='NORMALE',
                                  stato='ITALIA',
                                  forza_destinazione='false',
                                  provincia='RM',
                                  complemento_nominativo='DEST CN',
                                  cognome='ITALIANE',
                                  nome='POSTE',
                                  citta='ROMA',
                                  complemento_indirizzo='DEST CI',
                                  cap='00144',
                                  id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.s.valida_destinatari(idr, aod)
        m = self.f.create_mittente(dug='VIA',
                                   toponimo='DANTE ALIGHIERI',
                                   numero_civico='99',
                                   tipo_indirizzo='NORMALE',
                                   stato='Italia',
                                   forza_destinazione='false',
                                   provincia='MI',
                                   complemento_nominativo='DEST CN',
                                   cognome='Systems',
                                   nome='Thunder',
                                   citta='LIMITO DI PIOLTELLO',
                                   complemento_indirizzo='DEST CI',
                                   cap='20096')
        d = self.f.create_documento(self.filename)
        rs = self.f.create_rol_submit(m, aod, d)
        result = self.s.invio(idr, "NPCE Client Test", rs)

    def test_rol_10(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                  toponimo='EUROPA',
                                  numero_civico='75',
                                  tipo_indirizzo='CASELLA POSTALE',
                                  stato='ITALIA',
                                  forza_destinazione='false',
                                  provincia='RM',
                                  complemento_nominativo='DEST CN',
                                  cognome='ITALIANE',
                                  nome='POSTE',
                                  citta='ROMA',
                                  complemento_indirizzo='DEST CI',
                                  cap='00144',
                                  id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.s.valida_destinatari(idr, aod)
        self.s.valida_destinatari(idr, aod)
        m = self.f.create_mittente(dug='VIA',
                                   toponimo='DANTE ALIGHIERI',
                                   numero_civico='99',
                                   tipo_indirizzo='NORMALE',
                                   stato='Italia',
                                   forza_destinazione='false',
                                   provincia='MI',
                                   complemento_nominativo='DEST CN',
                                   cognome='Systems',
                                   nome='Thunder',
                                   citta='LIMITO DI PIOLTELLO',
                                   complemento_indirizzo='DEST CI',
                                   cap='20096')
        d = self.f.create_documento(self.filename)
        rs = self.f.create_rol_submit(m, aod, d)
        result = self.s.invio(idr, "NPCE Client Test", rs)
        
    def test_rol_11(self):
        idr = self.s.recupera_id_richiesta()
        d = self.f.create_destinatario(dug='VIALE',
                                  toponimo='EUROPA',
                                  numero_civico='75',
                                  tipo_indirizzo='NORMALE',
                                  stato='ITALIA',
                                  forza_destinazione='false',
                                  provincia='RM',
                                  complemento_nominativo='DEST CN',
                                  cognome='ITALIANE',
                                  nome='POSTE',
                                  citta='ROMA',
                                  complemento_indirizzo='DEST CI',
                                  cap='00144',
                                  id_destinatario='1')
        aod = self.f.create_array_of_destinatario((d,))
        self.s.valida_destinatari(idr, aod)
        m = self.f.create_mittente(dug='VIA',
                                   toponimo='DANTE ALIGHIERI',
                                   numero_civico='99',
                                   tipo_indirizzo='NORMALE',
                                   stato='Italia',
                                   forza_destinazione='false',
                                   provincia='MI',
                                   complemento_nominativo='DEST CN',
                                   cognome='Systems',
                                   nome='Thunder',
                                   citta='LIMITO DI PIOLTELLO',
                                   complemento_indirizzo='DEST CI',
                                   cap='20096')
        d = self.f.create_documento(self.filename)
        rs = self.f.create_rol_submit(m, aod, d)
        result = self.s.invio(idr, "NPCE Client Test", rs)
        # recupero il documento convertito

        print result