# -*- coding: utf-8 -*-

from south.db import db
from jumbo.db import HackForeignKey
from django.db import models
from jumbo.db.models import StatusField, HTMLField
from jumbo.apps.template.models import *

class Migration:
    
    def forwards(self, orm):
        
        # Adding model 'Template'
        db.create_table('template_template', (
            ('active', models.BooleanField(default=True, verbose_name=_('active'))),
            ('default', HTMLField(null=True, verbose_name=_('Default Text'), blank=True)),
            ('description', models.CharField(verbose_name=_('description'), max_length=255, null=True, blank=True)),
            ('id', models.AutoField(primary_key=True)),
            ('name', models.CharField(max_length=50, verbose_name=_('name'))),
        ))
        db.send_create_signal('template', ['Template'])
        
        # Adding model 'TemplateTranslation'
        db.create_table('template_templatetranslation', (
            ('text', HTMLField(null=True, verbose_name=_('translated text'), blank=True)),
            ('id', models.AutoField(primary_key=True)),
            ('language', models.ForeignKey(orm['i18n.Language'], verbose_name=_('language'))),
            ('template', models.ForeignKey(orm.Template, related_name='translations', verbose_name=_('template translation'))),
        ))
        db.send_create_signal('template', ['TemplateTranslation'])
        
    
    
    def backwards(self, orm):
        
        # Deleting model 'Template'
        db.delete_table('template_template')
        
        # Deleting model 'TemplateTranslation'
        db.delete_table('template_templatetranslation')
        
    
    
    models = {
        'i18n.language': {
            'Meta': {'ordering': "('name',)"},
            '_stub': True,
            'id': ('models.AutoField', [], {'primary_key': 'True'})
        },
        'template.template': {
            'Meta': {'ordering': "('name',)"},
            'active': ('models.BooleanField', [], {'default': 'True', 'verbose_name': "_('active')"}),
            'default': ('HTMLField', [], {'null': 'True', 'verbose_name': "_('Default Text')", 'blank': 'True'}),
            'description': ('models.CharField', [], {'verbose_name': "_('description')", 'max_length': '255', 'null': 'True', 'blank': 'True'}),
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'name': ('models.CharField', [], {'max_length': '50', 'verbose_name': "_('name')"})
        },
        'template.templatetranslation': {
            'id': ('models.AutoField', [], {'primary_key': 'True'}),
            'language': ('models.ForeignKey', ['Language'], {'verbose_name': "_('language')"}),
            'template': ('models.ForeignKey', ['Template'], {'related_name': "'translations'", 'verbose_name': "_('template translation')"}),
            'text': ('HTMLField', [], {'null': 'True', 'verbose_name': "_('translated text')", 'blank': 'True'})
        }
    }
    
    complete_apps = ['template']
