# -*- coding: utf-8 -*-
from django.utils.translation import ugettext_lazy as _
from django.utils.translation import get_language

from jumbo.apps.template.models import Template
from jumbo.apps.menu.models import Menu
from jumbo.shortcuts import render_to_response, render_to_string

def template_preview(request):
    if request.POST.has_key('text_preview'):
        text = request.POST['text_preview']
    else:
        return render_to_response('generic_error.html', request=request, error=_('Text Not Found'))

    return render_to_response('template/template_preview.html', request=request, text=text,)


def template_menu_view(request, slug, template_name='template/static.html'):
    m = Menu.objects.get(slug=slug)
    lang = get_language()[0:2]
    current = None
    template = m.template

    if template:
        try:
            current = template.menu.all()[0]
        except:
            current = None

        for tr in template.translations.all():
            if tr.language.code == lang:
                template = tr
    return render_to_response(template_name, request=request, templatez=template, current=current)

def template_view(request, slug, template_name='template/static.html'):
    lang = get_language()[0:2]
    template = Template.objects.get(slug__iexact=slug)

    try:
        current = template.menu.all()[0]
    except:
        current = None

    for tr in template.translations.all():
        if tr.language.code == lang:
            template = tr

    return render_to_response(template_name, request=request, templatez=template, current=current)
