"""
This file was generated with the custommenu management command, it contains 
the classes for the admin menu, you can customize this class as you want.

To activate your custom menu add the following to your settings.py::
    ADMIN_TOOLS_MENU = 'cybergun.menu.CustomMenu'
"""
import os, os.path
from django.core.urlresolvers import reverse
from django.utils.translation import ugettext as _
from django.conf import settings
from django.utils.importlib import import_module
from admin_tools.menu import items, Menu
#from jumbo.middleware.thread_local import get_current_user, get_request

def get_extended_menu():
    """
    Returns the admin menu defined by the user or the default one.
    """
    menu_cls = getattr(
        settings,
        'ADMIN_EXTENDED_MENU',
        'admin_tools.menu.DefaultMenu'
    )
    mod, inst = menu_cls.rsplit('.', 1)
    mod = import_module(mod)
    return getattr(mod, inst)()


class JumboExtendedMenu(Menu):
    def init_with_context(self, context):
        """
        Use this method if you need to access the request context.
        """
        super(JumboExtendedMenu, self).init_with_context(context)
        try:
            current_app = context['app_label']
        except KeyError, e:
            current_app = None
            
        dirs_list = []
        #for module in settings.INSTALLED_APPS:
        #if current_app == module:
        if current_app:
            mm = "%s.jmenu" % current_app
            try:
                menu_module = import_module(mm)
                menu_module.add_extended_menuitems(self.children, current_app)
            except ImportError, e:
                pass