#!/usr/bin/env python

import os, sys

# PATH is the absolute path leading to parent directory
PATH, _ = os.path.split(os.path.dirname(os.path.realpath(__file__)))
SITE_PACKAGES = os.path.join(PATH, 'site-packages')

# insert every package listed in site-packages directory
for pkg in os.listdir(SITE_PACKAGES):
    sys.path.insert(0, os.path.join(SITE_PACKAGES, pkg))

sys.path.insert(0, PATH)

from django.core.management import execute_manager
try:
    import settings # Assumed to be in the same directory.
except ImportError:
    sys.stderr.write("Error: Can't find the file 'settings.py' in the directory containing %r. It appears you've customized things.\nYou'll have to run django-admin.py, passing it your settings module.\n(If the file settings.py does indeed exist, it's causing an ImportError somehow.)\n" % __file__)
    sys.exit(1)

if __name__ == "__main__":
    execute_manager(settings)
