from django.conf.urls.defaults import *
from django.contrib import admin

from django.conf import settings
from jumbo.admin.sites import root_site
from dajaxice.core import dajaxice_autodiscover

admin.autodiscover()
dajaxice_autodiscover()

js_info_dict = {
    'packages': ('jumbo',),
}

JUMBO_URL = patterns('',
    url(r'^admin/doc/'                    , include('django.contrib.admindocs.urls')),
    url(r'^admin/'                        , include(admin.site.urls)),
    url(r'^adminroot/'                    , include(root_site.urls)),
    url(r'^i18n/'                         , include('django.conf.urls.i18n')),
    url(r'^autocomplete/'                 , include('jumbo.apps.autocomplete.urls')),
    url(r'^chaining/'                     , include('jumbo.apps.smart_selects.urls')),
    url(r'^admin_tools/'                  , include('admin_tools.urls')),
    url(r'^%s/' % settings.DAJAXICE_MEDIA_PREFIX, include('dajaxice.urls')),
    (r'^comments/'                        , include('django.contrib.comments.urls')),
    url(r'^downloads/'                    , 'jumbo.views.generic.generic_views.respond_as_attachment'
                                          , name = 'download_file'),

    (r'^jsi18n/(?P<packages>\S+?)/$'   , 'django.views.i18n.javascript_catalog'),
)

if settings.ENABLE_FACEBOOK_LOGIN:
     JUMBO_URL += patterns('',
           (r'facebook/', include('facebook.urls')),
)
#    JUMBO_URL += patterns('', (r'^facebook/', include('facebookconnect.urls')),)

#if settings.INCLUDE_USERPROFILE_URLS:
#    JUMBO_URL += patterns('',(r'^accounts/'                        , include('userprofile.urls')),)
