from django.conf import settings
from django.contrib.auth.models import User
from facebook.models import FacebookUser
from jumbo.middleware.thread_local import get_request

class EmailOrUsernameModelBackend(object):
    def authenticate(self, username=None, password=None):
        if '@' in username:
            kwargs = {'email': username.lower()}
        else:
            kwargs = {'username': username}
        try:
            user = User.objects.get(**kwargs)
            if user.check_password(password):
                request = get_request()
                if settings.ENABLE_FACEBOOK_LOGIN:
                    if 'fb_id' in request.session:
                        fb_user = FacebookUser(user = user,
                                               facebook_id = request.session['fb_id'],
                                               access_token = request.session['fb_token'])
                        fb_user.save()
                        del request.session['fb_id']
                        del request.session['fb_token']
                return user
        except User.DoesNotExist:
            return None

    def get_user(self, user_id):
        try:
            return User.objects.get(pk=user_id)
        except User.DoesNotExist:
            return None
