# -*- coding: utf-8 -*-

from django.conf import settings
from django.contrib.auth import REDIRECT_FIELD_NAME
from django.http import HttpResponseRedirect
from urllib import quote

def allow_anonymous(func):
    func.allow_anonymous = True
    return func

class RequireLogin:
    def process_view(self, request, func, args, kwargs):
        if not getattr(func, 'allow_anonymous', False) and request.user.is_anonymous():
            return HttpResponseRedirect('%s?%s=%s' % (settings.LOGIN_URL, REDIRECT_FIELD_NAME, quote(request.get_full_path())))

