from django import template
from django.core.urlresolvers import reverse

from admin_tools.utils import get_media_url, get_admin_site_name
from jumbo.conf.admin_extended_menu import get_extended_menu
from jumbo.conf.admin_contract_menu import get_contract_menu

register = template.Library()

tag_func = register.inclusion_tag('admin_tools/menu/dummy.html', takes_context=True)
def admin_render_extended_menu(context):
    menu = get_extended_menu()
    menu.init_with_context(context)

    context.update({
        'template': menu.template,
        'menu': menu,
        'media_url': get_media_url(),
        'admin_url': reverse('%s:index' % get_admin_site_name(context)),
    })
    return context
admin_render_extended_menu = tag_func(admin_render_extended_menu)


tag_func = register.inclusion_tag('admin_tools/menu/dummy.html', takes_context=True)
def admin_render_contract_menu(context):
    menu = get_contract_menu()
    menu.init_with_context(context)

    context.update({
        'template': menu.template,
        'menu': menu,
        'media_url': get_media_url(),
        'admin_url': reverse('%s:index' % get_admin_site_name(context)),
    })
    return context
admin_render_contract_menu = tag_func(admin_render_contract_menu)