from django import template
from django.forms.util import flatatt
from django.conf import settings
from jumbo.utils.functions import get_settings

register = template.Library()

@register.inclusion_tag("jumbo/tags/click_to_call.html")
def click_to_call(number):
    try:
        # Se l'applicazione Asterisk e' installata chiamo la
        # relativa funzione per controllare/pulire il numero di
        # telefono e tornare la relativa icona.
        # Altrimenti chiamo il template con il parametro asterisk a False
        # ad indicare che l'applicazione non e' installata
        from asterisk.utils import click_to_call as utils_click_to_call
    except ImportError:
        return  {'asterisk': False, 'number': number}

    return utils_click_to_call(number)
