from django import template
from django.template import Library
from django.template import RequestContext
from django.template import resolve_variable
from jumbo.shortcuts import render_to_string

GOOGLE_MAPS_API_KEY = {
    "siex":"ABQIAAAAXKo3B_qoyoK-ULgQBgknhRSOsuAzotLWyVOdVMqOgojBJG2PyxTxBxVVyEeHMYYPBT7R9rv4R6xipQ",
}
CURRENT_SITE = "siex"

register = Library()

INCLUDE_TEMPLATE = """
<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;sensor=true&amp;key=%s" type="text/javascript"></script>
<script>
$(document).ready(function() {
    $(".gmaps_body").hide();
    $(".gmaps_header").toggle(
        function() {
            objid = $(this).next(".gmaps_body")[0].id;
            //Create the function call from function name and parameter.
            var funcCall = "view_" + objid + "();";

            $("#"+objid).show();
            //Call the function
            eval(funcCall);
        },
        function() {
            $(this).next(".gmaps_body").hide();
        }
    );
});
</script>
""" % (GOOGLE_MAPS_API_KEY [ CURRENT_SITE ] , )

# {% gmap name:mimapa width:300 height:300 address:"Via dei Pestagalli, 7, Milano" zoom:20 view:hybrid %} Message for a marker at that point {% endgmap %}

class GMapNode (template.Node):
    def __init__(self, params, nodelist):
        self.params = {}
        self.nodelist = nodelist

        for item in params.keys():
            self.params[item] = template.Variable(params[item])


    def render (self, context):
        for k,v in self.params.items():
            try:
                self.params[k] = v.resolve(context)
            except Exception, e:
                pass
            if k == "view":
                if str(v)=="satellite": 
                    v = 1
                elif str(v)=="map":
                    v = 0
                else:
                    v = 2
                self.params[k] = v
        self.params["message"] = self.nodelist.render(context).replace("\n", "<br />")
        return render_to_string("jumbo/tags/google_maps.html", params=self.params)

def do_gmap(parser, token):
    items = token.split_contents()

    nodelist = parser.parse(('endgmap',))
    parser.delete_first_token()

    #Default values 
    parameters={
            'name'      : "default",
            'width'     : "300",
            'height'    : "300",
            #'latitude'  : "33",
            #'longitude' : "-3",
            'address'   : "",
            'zoom'      : "15",
            'view'      : "hybrid", # map, satellite, hybrid
            'message'   : "No message",
    }
    for item in items[1:]:
        param, value = item.split(":")
        param = param.strip()
        value = value.strip()
        
        if parameters.has_key(param):
            if value[0]=="\"":
                value = value[1:-1]
            parameters[param] = value
        
    return GMapNode(parameters, nodelist)

class GMapScriptNode (template.Node):
    def __init__(self):
        pass
    def render (self, context):
        return INCLUDE_TEMPLATE

def do_gmap_script(parser, token):
    try:
        tag_name = token.split_contents()
    except ValueError:
        raise template.TemplateSyntaxError("Il tag non richiede argomenti" % token.contents[0])
    return GMapScriptNode()

register.tag('gmap', do_gmap)
register.tag('gmap-script', do_gmap_script)
